
module fifo_par_dp_ram (clk,rst,data_i, data_o,waddr, raddr, wen, ren, amnt);

//------Parameters declaration:---------
	parameter  ADDRS   = 4;
	parameter  WIDTH   = 8;	
//--------------------------------------

 //-----External signal declaration-----
	input   [WIDTH-1:0]  data_i;
	input                clk;	
	input                rst;
	input                wen;
	input                ren;
	input   [ADDRS-1:0]  waddr;
	input   [ADDRS-1:0]  raddr;
	input   [ADDRS:0]    amnt;

	output  [WIDTH-1:0]  data_o;
//---------------------------------------

 //-----internal signal declaration------
	reg     [WIDTH-1:0]  mem [0:((1 << ADDRS)-1)];
	
	reg     [WIDTH-1:0]  data_intt;
	reg                  renn;
	reg                  flag;
	reg     [ADDRS-1:0]  raddr_fall;
//---------------------------------------




always @ ( posedge clk, posedge rst) begin
 if(rst)
data_intt <= 0;
else  begin
	if(ren) begin
		if(amnt == 0)
			data_intt <= 8'bxxxxxxxx;
	
		else begin
			data_intt <= mem[raddr];
		end
	end
end
end


always @ (posedge clk, posedge rst) begin
    	if(rst) begin
		mem[0] <= 0;
		mem[1] <= 0;
	end
	else if(wen && (amnt !=(1 << ADDRS) )) mem[waddr] <= data_i;		
		
end
assign data_o = data_intt;
endmodule

