

module fifo_par_r(clk, rst,wen,ren,waddr, raddr, full, empty, amntt);


//------Parameters declaration:---------
	parameter  ADDRS = 4;
	parameter  ADDRQ = 2; 
	parameter  WIDTH = 8;   
//--------------------------------------

//-----External signal declaration------
	input                 clk;	
	input                 rst;
	input                 wen;
	input                 ren;
	
	output   [ADDRS-1:0]  waddr;
	output   [ADDRS-1:0]  raddr;

	output    	      full;
	output    	      empty;

//---------------------------------------

//-----internal signal declaration-------
	output    [ADDRS:0] amntt;
	
	reg    [ADDRS-1:0]  wa;
	reg    [ADDRS-1:0]  ra;
	reg                 full_int;
	reg                 empty_int;
    reg                 full_int_;
	reg     [ADDRS:0]   amnt;
	
   
	
//---------------------------------------

always @ (posedge clk, posedge rst)
	begin
		if(rst) begin 
			ra    <= 0;
			wa    <= 0;
			amnt  <= 0;
		end
		else  begin
				
			if(wen & !ren & !full_int) begin
				wa<= wa+1;
				amnt <= amnt+1;
				
			end

			if (wen & ren) begin				
				if(amnt != 0)  begin
					ra <= ra + 1;
					wa <= wa + 1;
				end
				else begin
					amnt <= amnt + 1;
					wa <= wa+1;
					
				end
			end	
			
			if(!wen & ren ) begin
				if(amnt == 1) begin
					ra <= 0;
					wa <= 0;
					amnt <= 0;
					
					
				end
				else if(amnt != 0) begin
					ra <= ra + 1;
					amnt <= amnt - 1;
				end
			end

		end
end
//--------------------
		
always @ (negedge clk, posedge rst)
begin
if(rst) begin
    full_int  <= 0;
    empty_int <= 1;
end
else  begin
    full_int <= amnt[ADDRS];
    empty_int <= (amnt==0);
end
end

assign waddr = wa;
assign raddr = ra;
assign full = full_int;
assign empty = empty_int;
assign amntt = amnt;


endmodule
