/** @file fifo_msg.h
 * Header for messages used inside test system.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/message.hpp>

namespace cpptesk {
namespace examples {
namespace fifo {

/// Class for messages with input data (stimuli)
CPPTESK_MESSAGE(InputData)
{
public:
    InputData();
    virtual ~InputData();

    /// Clone of message support.
    CPPTESK_SUPPORT_CLONE(InputData);
    /// Registration of the data field with 8-bit width.
    CPPTESK_DECLARE_FIELD(data, 8);
};

/// Class for messages with output data (reactions)
CPPTESK_MESSAGE(OutputData)
{
public:
    OutputData();
    OutputData(uint8_t datum);
    virtual ~OutputData();

    /// Clone of message support.
    CPPTESK_SUPPORT_CLONE(OutputData);
    /// Registration of the data field with 8-bit width.
    CPPTESK_DECLARE_FIELD(data, 8);
};

}}}

