/** @file testrepository.cpp
 * Test repository.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <utils/testreg.h>
#include <fifo_scen.h>

using namespace cpptesk::examples::fifo;

/// Objects of ExampleScenario class.
ExampleScenario scen_rnd_example;
ExampleScenario scen_fsm_example;

/// Repository. Each row contains object of test class, traverser and parameters of running.
TEST_REGISTRY_BEGIN
REGISTER_TEST(scen_rnd_example, engine::rnd, "-uerr=1 --length 10000 --parallel")
REGISTER_TEST(scen_fsm_example, engine::fsm, "-uerr=1")
TEST_REGISTRY_END

