/*
 * Copyright 2010 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _GENERATOR_TRACER_H_INCLUDED_
#define _GENERATOR_TRACER_H_INCLUDED_

#include <atl/map.h>

bool startTrace_TestEngine();

void endTrace_TestEngine(bool tracing_was_started_here);

void traceScenarioStart_TestEngine(const char *name, int argc, char **argv);

void traceScenarioEnd_TestEngine(void);

bool traceTransitionStart_TestEngine(const char *tran_id, const char *name, Object *value, bool accidental);

void traceTransitionEnd_TestEngine(const char *tran_id, const char *name, bool accidental);

void traceState_TestEngine(const char *state_id, const char *state);

void traceProperty_TestEngine(const char *property, const char *value);

void traceSystemInfo_TestEngine(const char *name, const char *info);

void traceExceptionInfo_TestEngine(const char *name, const char *info);

void traceNondeterminism_TestEngine(const char *start_state_id, int stimulus_id, const char *old_end_state_id, const char *new_end_state_id);

void traceTestSummary_TestEngine(Map *summary);

void flushTrace_TestEngine(void);

void processTraceParameters_TestEngine(const char *name, const char *cpu_id, int argc, char **argv);

#endif


